package jp.co.sra.jun.geometry.pluralities;

import java.util.Collection;

/**
 * JunBoundingBalls class
 * 
 *  @author    Mitsuhiro Asada
 *  @created   2007/05/30 (by m-asada)
 *  @updated   N/A
 *  @version   699 (with StPL8.9) based on Jun667 for Smalltalk
 *  @copyright 1999-2008 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2008 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunBoundingBalls.java,v 8.5 2008/02/20 06:30:57 nisinaka Exp $
 */
public class JunBoundingBalls extends JunBoundingObjects {
	/**
	 * Create a new instance of <code>JunBoundingBalls</code> and initialize it.
	 * 
	 * @category Instance creation
	 */
	public JunBoundingBalls() {
		super();
	}

	/**
	 * Set my bounding balls.
	 * 
	 * @param boundingBallCollection java.util.Collection
	 * @category accessing
	 */
	public void boundingBalls_(Collection boundingBallCollection) {
		this.boundingObjects_(boundingBallCollection);
	}

	/**
	 * Answer true if the receiver is a bounding balls, otherwise false.
	 * 
	 * @return boolean
	 * @see jp.co.sra.jun.geometry.abstracts.JunGeometry#isBoundingBalls()
	 * @category testing
	 */
	public boolean isBoundingBalls() {
		return true;
	}
}
