package jp.co.sra.jun.opengl.display;

/**
 * JunOpenGLDisplayView interface
 * 
 *  @author    MATSUDA Ryouichi
 *  @created   2000/01/10 (by MATSUDA Ryouichi)
 *  @updated   2003/05/14 (by nisinaka)
 *  @updated   2004/09/21 (by nisinaka)
 *  @updated   2007/08/23 (by nisinaka)
 *  @version   699 (with StPL8.9) based on Jun475 for Smalltalk
 *  @copyright 1999-2008 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2008 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunOpenGLDisplayView.java,v 8.12 2008/02/20 06:32:19 nisinaka Exp $
 */
public interface JunOpenGLDisplayView extends JunOpenGL3dView {

	/**
	 * Answer my model as JunOpenGLDisplayModel.
	 * 
	 * @return jp.co.sra.jun.opengl.display.JunOpenGLDisplayModel
	 * @category model accessing
	 */
	public JunOpenGLDisplayModel getOpenGLDisplayModel();

	/**
	 * Answer my current OpenGL view.
	 * 
	 * @return jp.co.sra.jun.opengl.display.JunOpenGL3dViewWrapper
	 * @deprecated since Jun683, the OpenGL view is myself.
	 * @category accessing
	 */
	public JunOpenGL3dViewWrapper getOpenGLView();

}
