package jp.co.sra.jun.topology.abstracts;

import jp.co.sra.jun.system.framework.JunAbstractObject;

/**
 * JunTopology class
 * 
 *  @author    ASTI Shanghai
 *  @created   UNKNOWN
 *  @updated   N/A
 *  @version   699 (with StPL8.9) based on Jun697 for Smalltalk
 *  @copyright 1999-2008 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2008 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunTopology.java,v 8.12 2008/02/20 06:33:01 nisinaka Exp $
 */
public abstract class JunTopology extends JunAbstractObject {
	/**
	 * Answer true if the receiver is a kind of topological proxy, otherwise false.
	 * 
	 * @return boolean
	 * @category testing
	 */
	public boolean isGeometry() {
		return false;
	}

	/**
	 * Answer true if the receiver is a kind of geometry, otherwise false.
	 * 
	 * @return boolean
	 * @category testing
	 */
	public boolean isTopologicalProxy() {
		return false;
	}

	/**
	 * Answer true if the receiver is a kind of topology, otherwise false.
	 * 
	 * @return boolean
	 * @category testing
	 */
	public boolean isTopology() {
		return true;
	}
}
