package jp.co.sra.jun.topology.euleroperators;

import jp.co.sra.jun.geometry.basic.Jun3dPoint;
import jp.co.sra.jun.topology.elements.*;

/**
 * JunMEVTestExamples class
 * 
 *  @author    ASTI Shanghai
 *  @created   UNKNOWN
 *  @updated   N/A
 *  @version   699 (with StPL8.9) based on JunXXX for Smalltalk
 *  @copyright 1999-2008 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2008 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunMEVTestExamples.java,v 8.10 2008/02/20 06:33:02 nisinaka Exp $
 */
public class JunMEVTestExamples extends jp.co.sra.jun.system.support.JunTestExamples {

	/**
	 * DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	public static boolean Example1() {
		JunMEVVL mevvl;
		JunMEV mev;
		mevvl = JunMEVVL.Body_point_point_(new JunBody(), new Jun3dPoint(0, 0, 0), new Jun3dPoint(1, 0, 0));
		mevvl.doOperation();
		mev = JunMEV.Body_vertex_loop_point_(mevvl.body(), mevvl.vertex2(), mevvl.loop(), new Jun3dPoint(0, 1, 0));
		mev.doOperation();
		mev.body().show();

		//#?# mev
		System.out.println("-------- #point");
		System.out.println(mev.point());
		System.out.println("-------- #loop");
		System.out.println(mev.loop());
		System.out.println("-------- #vertex2");
		System.out.println(mev.vertex2());
		System.out.println("-------- #edge2");
		System.out.println(mev.edge2());
		System.out.println("-------- #newVertex");
		System.out.println(mev.newVertex());
		System.out.println("-------- #newEdge");
		System.out.println(mev.newEdge());

		//return mev;
		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @return DOCUMENT ME!
	 */
	public static boolean Example2() {
		JunMEVVL mevvl;
		JunMEL mel;
		JunMEV mev1;
		JunMEV mev2;
		mevvl = JunMEVVL.Body_point_point_(new JunBody(), new Jun3dPoint(0, 0, 0), new Jun3dPoint(1, 0, 0));
		mevvl.doOperation();
		mel = JunMEL.Body_loop_vertex_vertex_(mevvl.body(), mevvl.loop(), mevvl.vertex1(), mevvl.vertex2());
		mel.doOperation();
		mev1 = JunMEV.Body_vertex_loop_point_(mevvl.body(), mevvl.vertex1(), mel.loop1(), new Jun3dPoint(0, 1, 0));
		mev1.doOperation();
		mev2 = JunMEV.Body_vertex_loop_point_(mevvl.body(), mevvl.vertex2(), mel.loop2(), new Jun3dPoint(0, 0, 1));
		mev2.doOperation();
		mev2.body().show();

		//return mev2;
		return true;
	}

	/**
	 * DOCUMENT ME!
	 * 
	 * @param args java.lang.String[]
	 */
	public static void main(String[] args) {
		new JunMEVTestExamples();
	}
}
