package jp.co.sra.jun.topology.graph;

import jp.co.sra.jun.system.framework.JunAbstractViewJPanel;

/**
 * JunElementalStuffSettingsViewSwing class
 * 
 *  @author    nisinaka
 *  @created   2006/04/17 (by nisinaka)
 *  @updated   N/A
 *  @version   699 (with StPL8.9) based on Jun598 for Smalltalk
 *  @copyright 1999-2008 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2008 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunElementalStuffSettingsViewSwing.java,v 8.10 2008/02/20 06:33:02 nisinaka Exp $
 */
public abstract class JunElementalStuffSettingsViewSwing extends JunAbstractViewJPanel implements JunElementalStuffSettingsView {

	/**
	 * Create a new instance of JunElementalStuffSettingsViewSwing and initialize it.
	 *
	 * @param anElementalStuffSettings
	 * @category Instance creation
	 */
	public JunElementalStuffSettingsViewSwing(JunElementalStuffSettings anElementalStuffSettings) {
		super(anElementalStuffSettings);
	}

	/**
	 * Answer my model as JunElementalStuffSettings.
	 * 
	 * @return jp.co.sra.jun.topology.graph.JunElementalStuffSettings
	 * @see jp.co.sra.jun.topology.graph.JunElementalStuffSettingsView#getElementalStuffSettings()
	 * @category model accessing
	 */
	public JunElementalStuffSettings getElementalStuffSettings() {
		return (JunElementalStuffSettings) this.model();
	}

}
