package jp.co.sra.jun.vrml.field.sf;

import jp.co.sra.smalltalk.StSymbol;

/**
 * JunVrmlSFEnumField class
 * 
 *  @author    ASTI Beijing
 *  @created   UNKNOWN
 *  @updated   2000/03/17 (by nisinaka)
 *  @version   699 (with StPL8.9) based on JunXXX for Smalltalk
 *  @copyright 1999-2008 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2008 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunVrmlSFEnumField.java,v 8.11 2008/02/20 06:33:15 nisinaka Exp $
 */
public class JunVrmlSFEnumField extends jp.co.sra.jun.vrml.field.abstracts.JunVrmlSFField {
	protected StSymbol value;
	protected StSymbol[] validSymbols;

	/**
	 * Create a JunVrmlSFBoolField and initialize it.
	 * 
	 * @param anObject java.lang.Object
	 */
	public JunVrmlSFEnumField(Object anObject) {
		this((StSymbol) anObject);
	}

	/**
	 * Create a new instance of JunVrmlSFEnumField and initialize it.
	 * 
	 * @param aSymbol jp.co.sra.smalltalk.StSymbol
	 */
	public JunVrmlSFEnumField(StSymbol aSymbol) {
		super();
		this.value_(aSymbol);
	}

	/**
	 * Answer the valid symbols. Creation date: (2000/03/17 17:08:37)
	 * 
	 * @return jp.co.sra.smalltalk.StSymbol[]
	 */
	public StSymbol[] validSymbols() {
		return validSymbols;
	}

	/**
	 * Set the valid symbols. Creation date: (2000/03/17 17:07:50)
	 * 
	 * @param symbols jp.co.sra.smalltalk.StSymbol[]
	 */
	public void validSymbols(StSymbol[] symbols) {
		validSymbols = symbols;
	}

	/**
	 * Answer my value.
	 * 
	 * @return jp.co.sra.smalltalk.StSymbol
	 */
	public StSymbol value() {
		return value;
	}

	/**
	 * Set my value.
	 * 
	 * @param aSymbol jp.co.sra.smalltalk.StSymbol
	 */
	public void value_(StSymbol aSymbol) {
		value = aSymbol;
	}
}
